# Python client for Binance API

This package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

Please do not edit the generated code manually, but rather regenerate it from [OpenXAPI](https://github.com/openxapi/openxapi).

- API version: 0.1.1
- Package version: 0.1.1

## Supported APIs

| Product | Supported | Module | Documentation |
|---------|:-----------:|--------|---------------|
| Spot | ✅ | binance.spot | [Spot API](binance/spot_README.md) |
| USD-M Futures | ✅ | binance.derivatives.umfutures | [USD-M Futures API](binance/derivatives/umfutures_README.md) |
| COIN-M Futures | ✅ | binance.derivatives.cmfutures | [COIN-M Futures API](binance/derivatives/cmfutures_README.md) |
| Options | ✅ | binance.derivatives.options | [Options API](binance/derivatives/options_README.md) |
| Porfolio Margin | ✅ | binance.derivatives.pmargin | [Portfolio Margin API](binance/derivatives/pmargin_README.md) |
| Porfolio Margin Pro | ✅ | binance.derivatives.pmarginpro | [Portfolio Margin Pro API](binance/derivatives/pmarginpro_README.md) |
| Futures Data | ✅ | binance.derivatives.futuresdata | [Futures Data API](binance/derivatives/futuresdata_README.md) |
| Margin | ✅ | binance.margin | [Margin API](binance/margin_README.md) |
| Algo | ✅ | binance.algo | [Algo API](binance/algo_README.md) |
| Wallet | ✅ | binance.wallet | [Wallet API](binance/wallet_README.md) |
| Copy Trading | ✅ | binance.copytrading | [Copy Trading API](binance/copytrading_README.md) |
| Sub-Account | ✅ | binance.subaccount | [Sub-Account API](binance/subaccount_README.md) |


## Requirements.

Python 3.8+

## Installation & Usage

```bash
pip install openxapi-binance
```

## Getting Started

In your own code, to use this library to connect and interact with spot,
you can run the following:

```python
import os
import time
from pprint import pprint

from binance import spot
from binance.spot.rest import ApiException
from binance.spot.auth import BinanceAuth

# Defining the host is optional and defaults to https://api.binance.com
# See configuration.py for a list of all supported configuration parameters.
configuration = spot.Configuration(
    host = "https://api.binance.com"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

conf = spot.Configuration(
    auth=BinanceAuth(
        api_key=os.getenv("BINANCE_API_KEY"),
        # secret_key=os.getenv("BINANCE_SECRET_KEY"), # if you want to use HMAC auth
        private_key_path="/path/to/private_key.pem", # Automatically detects RSA/Ed25519 private keys
    ),
)

# Enter a context with an instance of the API client
with spot.ApiClient(conf) as api_client:
    # Create an instance of the API class
    api_instance = spot.AccountApi(api_client)
    try:
        # Query Commission Rates (USER_DATA)
        api_response = api_instance.spot_get_account_v3(
            timestamp=int(time.time() * 1000)
        )
        print("The response of AccountApi->spot_get_account_v3:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AccountApi->spot_get_account_v3: %s\n" % e)
```
